/**
 * A class that acts as a Piano synthesizer.
 */
public class PianoPlayer
{
    public static void synthesize() 
    {
        /* Constants */
        double CONCERT_A = 440.0; //frequency of a Concert A
        double CONCERT_C = CONCERT_A * Math.pow(2, 3.0/12.0); //frequency of a Concert C


        /* Initialize Variables */
        //create two piano strings, for concert A and C
        PianoString stringA = new PianoString(CONCERT_A);
        PianoString stringC = new PianoString(CONCERT_C);

        IOFrame frame = new IOFrame("Piano Player", 600, 150); //an interaction window to use. Make sure it has focus to type in it!


        /* The "main" loop */
        while(true) //continually process input
        {
            if(frame.hasMoreKeysTyped()) //check if there has been a key pressed recently 
            {
                char key = frame.getNextKeyTyped(); //find out which key
                System.out.println("You pressed '"+key+"'");

                //pluck a string based on that key
                if(key == 'a') 
                { 
                    stringA.pluck(); 
                }
                else if(key == 'c') 
                { 
                    stringC.pluck(); 
                }
            }

            //1. compute the superposition of samples (the sum of all our String sounds)
            double sample = stringA.sample() + stringC.sample();

            //2. play the sample on standard audio ((a provided static class))
            StdAudio.play(sample);

            //3. advance the simulation of each guitar string by one step
            stringA.update();
            stringC.update();
        }
    }
}
