/**
 * A Tester for the PianoString Karplus-Strong algorithm
 *
 * @author Adapted from UPenn.
 */
public class PianoStringTester
{
    public static void test()
    {
        //tests the Karplus-Strong algorithm by applying a known set of samples (rather than a random plucking).
        
        //below are the actual values (rounded)
        double[] expected = {
            0.2,
            0.4,
            0.5,
            0.3,
            -0.2,
            0.4,
            0.3,
            0.0,
            -0.1,
            -0.3,
            0.2982,
            0.4473,
            0.3976,
            0.0497,
            0.0994,
            0.3479,
            0.1491,
            -0.0497,
            -0.1988,
            -0.0009,
            0.3705,
            0.4199,
            0.2223,
            0.0741,
            0.2223,
        };
        
        double[] samples = { .2, .4, .5, .3, -.2, .4, .3, .0, -.1, -.3 };  
        PianoString testString = new PianoString(samples); //call test constructor
        System.out.println("Sample   Expected  Actual");
        for (int i = 0; i < 25; i++) 
        {
            double sample = testString.sample(); //get a sample
            System.out.println(i+ "  "+expected[i] + "  " + sample); //compare to expected list
            testString.update(); //update for next sampling
        }
    }
}
